import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "moebius92.ColorBar";
import "moebius92.Handlers";
import "moebius92.Misc";

_G.trim = function(s)
	return string.gsub(s, "^%s*(.-)%s*$", "%1");
end

local baseDurationImageID = 0x41007E35;

captainBuffs = { };
captainBuffs[1] = { icon = 0x410087BB, name = { ["Focus"] = true, ["On Guard"] = true, ["Relentless Attack"] = true } };
captainBuffs[2] = { icon = 0x410087B4, name = { ["Motivated"] = true } };
captainBuffs[3] = { icon = 0x41003725, name = { ["In Defense of Middle-earth"] = true } };
captainBuffs[4] = {
	icon = 0x410D3FFA,
	name = {
		["Strength of Will (Blade-brother)"] = true,
		["Strength of Will (Shield-brother)"] = true,
		["Strength of Will (Song-brother)"] = true,
		["Strength of Will (Fellowship Blade-brother)"] = true,
		["Strength of Will (Fellowship Shield-brother)"] = true,
		["Strength of Will (Fellowship Song-brother)"] = true
	}
};
captainBuffs[5] = {
	icon = 0x4107E9F1,
	name = {
		["Inspired (Blade-brother)"] = true,
		["Inspired (Shield-brother)"] = true,
		["Inspired (Song-brother)"] = true,
		["Inspired (Fellowship Blade-brother)"] = true,
		["Inspired (Fellowship Shield-brother)"] = true,
		["Inspired (Fellowship Song-brother)"] = true
	}
};
captainBuffs[6] = { icon = 0x4109B53E, name = { ["Light of Elendil"] = true } };

classColor = { };
classColor[Turbine.Gameplay.Class.Burglar] =		Turbine.UI.Color(0.3, 0.0, 0.0, 0.0);
classColor[Turbine.Gameplay.Class.Captain] =		Turbine.UI.Color(0.3, 0.0, 0.0, 1.0);
classColor[Turbine.Gameplay.Class.Champion] =		Turbine.UI.Color(0.3, 1.0, 0.0, 0.0);
classColor[Turbine.Gameplay.Class.Guardian] =		Turbine.UI.Color(0.3, 1.0, 0.5, 0.0);
classColor[Turbine.Gameplay.Class.Hunter] =			Turbine.UI.Color(0.3, 0.0, 1.0, 0.0);
classColor[Turbine.Gameplay.Class.LoreMaster] =		Turbine.UI.Color(0.3, 0.0, 1.0, 1.0);
classColor[Turbine.Gameplay.Class.Minstrel] =		Turbine.UI.Color(0.3, 1.0, 1.0, 0.0);
classColor[Turbine.Gameplay.Class.RuneKeeper] =		Turbine.UI.Color(0.3, 1.0, 1.0, 1.0);
classColor[Turbine.Gameplay.Class.Warden] =			Turbine.UI.Color(0.3, 1.0, 0.0, 1.0);

debuffColor = { };
debuffColor[Turbine.Gameplay.EffectCategory.Fear] = Turbine.UI.Color(1.0, 1.0, 0.0, 1.0);
debuffColor[Turbine.Gameplay.EffectCategory.Wound] = Turbine.UI.Color(1.0, 1.0, 0.0, 0.0);
debuffColor[Turbine.Gameplay.EffectCategory.Disease] = Turbine.UI.Color(1.0, 1.0, 1.0, 0.0);
debuffColor[Turbine.Gameplay.EffectCategory.Poison] = Turbine.UI.Color(1.0, 0.0, 1.0, 0.0);

debuffOrder = { };
debuffOrder[Turbine.Gameplay.EffectCategory.Fear] = 2;
debuffOrder[Turbine.Gameplay.EffectCategory.Wound] = 3;
debuffOrder[Turbine.Gameplay.EffectCategory.Disease] = 4;
debuffOrder[Turbine.Gameplay.EffectCategory.Poison] = 5;

debuffType = { };
debuffType[2] = Turbine.Gameplay.EffectCategory.Fear;
debuffType[3] = Turbine.Gameplay.EffectCategory.Wound;
debuffType[4] = Turbine.Gameplay.EffectCategory.Disease;
debuffType[5] = Turbine.Gameplay.EffectCategory.Poison;

buffOrder = { }
buffOrder[Turbine.Gameplay.Class.Burglar] = { };
buffOrder[Turbine.Gameplay.Class.Burglar]["Signal: Conviction"] = 1;
buffOrder[Turbine.Gameplay.Class.Burglar]["Signal: Guile"] = 1;
buffOrder[Turbine.Gameplay.Class.Burglar]["Signal: Strength"] = 1;
buffOrder[Turbine.Gameplay.Class.Burglar]["Signal: Tactics"] = 1;

buffOrder[Turbine.Gameplay.Class.Captain] = { };
buffOrder[Turbine.Gameplay.Class.Captain]["Blade-brother"] = 1;
buffOrder[Turbine.Gameplay.Class.Captain]["Shield-brother"] = 1;
buffOrder[Turbine.Gameplay.Class.Captain]["Song-brother"] = 1;
buffOrder[Turbine.Gameplay.Class.Captain]["Watchful Shield-brother"] = 1;
buffOrder[Turbine.Gameplay.Class.Captain]["To Arms (Blade-brother)"] = 2;
buffOrder[Turbine.Gameplay.Class.Captain]["To Arms (Shield-brother)"] = 2;
buffOrder[Turbine.Gameplay.Class.Captain]["To Arms (Song-brother)"] = 2;
buffOrder[Turbine.Gameplay.Class.Captain]["To Arms (Fellowship Blade-brother)"] = 2;
buffOrder[Turbine.Gameplay.Class.Captain]["To Arms (Fellowship Shield-brother)"] = 2;
buffOrder[Turbine.Gameplay.Class.Captain]["To Arms (Fellowship Song-brother)"] = 2;
buffOrder[Turbine.Gameplay.Class.Captain]["War-cry"] = 3;
buffOrder[Turbine.Gameplay.Class.Captain]["Make Haste"] = 4;
buffOrder[Turbine.Gameplay.Class.Captain]["Rallying Cry"] = 4;
buffOrder[Turbine.Gameplay.Class.Captain]["Words of Courage"] = 4;
buffOrder[Turbine.Gameplay.Class.Captain]["Focus"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["In Defense of Middle-earth"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Inspired (Blade-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Inspired (Shield-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Inspired (Song-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Inspired (Fellowship Blade-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Inspired (Fellowship Shield-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Inspired (Fellowship Song-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Light of Elendil"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Motivated"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["On Guard"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Relentless Attack"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Strength of Will (Blade-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Strength of Will (Shield-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Strength of Will (Song-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Strength of Will (Fellowship Blade-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Strength of Will (Fellowship Shield-brother)"] = 5;
buffOrder[Turbine.Gameplay.Class.Captain]["Strength of Will (Fellowship Song-brother)"] = 5;

buffOrder[Turbine.Gameplay.Class.Champion] = { };

buffOrder[Turbine.Gameplay.Class.Guardian] = { };
buffOrder[Turbine.Gameplay.Class.Guardian]["Protection"] = 1;
buffOrder[Turbine.Gameplay.Class.Guardian]["Protection by the Sword"] = 1;
buffOrder[Turbine.Gameplay.Class.Guardian]["Shield Wall"] = 1;

buffOrder[Turbine.Gameplay.Class.Hunter] = { };
buffOrder[Turbine.Gameplay.Class.Hunter]["Find the Path"] = 1;
buffOrder[Turbine.Gameplay.Class.Hunter]["Cleanse Poison Resistance"] = 2;

buffOrder[Turbine.Gameplay.Class.LoreMaster] = { };
buffOrder[Turbine.Gameplay.Class.LoreMaster]["Charged Air"] = 1;
buffOrder[Turbine.Gameplay.Class.LoreMaster]["Sign of Power: Righteousness"] = 2;
buffOrder[Turbine.Gameplay.Class.LoreMaster]["Sign of Power: Vigilance"] = 3;

buffOrder[Turbine.Gameplay.Class.Minstrel] = { };
buffOrder[Turbine.Gameplay.Class.Minstrel]["Soliloquy of Spirit"] = 1;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Soliloquy of My Spirit"] = 1;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Enlivening Chord"] = 2;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Inspire Fellows Buff"] = 2;
buffOrder[Turbine.Gameplay.Class.Minstrel]["The Melody of Battle"] = 2;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Valar's Grace"] = 2;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Words of Courage: Fear Resistance"] = 2;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Fellowship's Heart"] = 3;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Tale of Battle"] = 4;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Tale of Frost and Flame"] = 4;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Tale of Heroism"] = 4;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Tale of Warding"] = 4;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Improved Tale of Warding"] = 4;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Anthem of Composure"] = 5;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Anthem of the Free People"] = 5;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Anthem of Prowess"] = 5;
buffOrder[Turbine.Gameplay.Class.Minstrel]["Anthem of War"] = 5;

buffOrder[Turbine.Gameplay.Class.RuneKeeper] = { };
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Armaments of Flame"] = 1;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Armaments of Storm"] = 1;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Armaments of Winter"] = 1;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Weapon of Flame"] = 1;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Weapon of Storm"] = 1;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Weapon of Winter"] = 1;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Glorious Foreshadowing"] = 1;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Wondrous Foreshadowing"] = 1;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Writ of Health - Tier 1"] = 2;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Writ of Health - Tier 2"] = 2;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Writ of Health - Tier 3"] = 2;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Mending Verse"] = 3;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Essay of Exaltation"] = 4;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Prelude to Hope"] = 4;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Rousing Words"] = 4;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["That Which Does Not Kill Us"] = 4;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Do not fall to Fire"] = 5;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Do not fall to Frost"] = 5;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Do not fall to Lightning"] = 5;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Do Not Fall This Day"] = 5;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["Shall Not Fall This Day"] = 5;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["The Blade Will Not Wound"] = -3;
buffOrder[Turbine.Gameplay.Class.RuneKeeper]["The Fang Will Not Poison"] = -5;

buffOrder[Turbine.Gameplay.Class.Warden] = { };
buffOrder[Turbine.Gameplay.Class.Warden]["Conviction"] = 1;

combatStates = { };
combatStates["Dazed"] = true;
combatStates["Feared"] = true;
combatStates["Knocked Down"] = true;
combatStates["Knocked Out"] = true;
combatStates["Recovering"] = true;
combatStates["Rooted"] = true;
combatStates["Stunned"] = true;
combatStates["Vulnerable"] = true;

readyColor = { };
readyColor[Turbine.Gameplay.ReadyState.Ready] = Turbine.UI.Color(1.0, 0.0, 1.0, 0.0);
readyColor[Turbine.Gameplay.ReadyState.NotReady] = Turbine.UI.Color(1.0, 1.0, 0.0, 0.0);

PartyMemberWindow = class(Turbine.UI.Control);

function PartyMemberWindow:Constructor(parent, member, size, width)
	Turbine.UI.Control.Constructor(self);

	self.parent = parent;
	self.member = member;
	self.class = member:GetClass();
	self.size = size;
	self.dead = false;
	self.damage = 0;
	self.rolls = { };
	self.rollOrder = nil;
	self.memberHandle = { };
	member:RegisterForClickHandling(self);

	self:SetSize(width + size * 11, size);

	if classColor[self.class] ~= nil then
		self:SetBackColor(classColor[self.class]);
	else
		self:SetBackColor(Turbine.UI.Color(0.2, 1.0, 1.0, 1.0));
	end

	self.name = Turbine.UI.Label();
	self.name:SetOutlineColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.0));
	self.name:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.name:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.name:SetMultiline(false);
	self.name:SetZOrder(100);
	self.name:SetParent(self);
	self.name:SetPosition(size, 0);
	self.name:SetSize(size * 5, size);
	self.name:SetMouseVisible(false);
	self.memberHandle["IsLinkDeadChanged"] = moebius92.Handlers.AddEventHandler(self.member, "IsLinkDeadChanged", function(sender, args) self:UpdateName(); end);
	self.memberHandle["IsVoiceEnabledChanged"] = moebius92.Handlers.AddEventHandler(self.member, "IsVoiceEnabledChanged", function(sender, args) self:UpdateName(); end);
	self.memberHandle["NameChanged"] = moebius92.Handlers.AddEventHandler(self.member, "NameChanged", function(sender, args) self:UpdateName(); end);
	self:UpdateName();

	self.ready = Turbine.UI.Control();
	self.ready:SetZOrder(100);
	self.ready:SetParent(self);
	self.ready:SetPosition(size / 4, size / 4);
	self.ready:SetSize(size / 2, size / 2);
	self.ready:SetVisible(true);
	self.ready:SetMouseVisible(false);
	self.memberHandle["ReadyStateChanged"] = moebius92.Handlers.AddEventHandler(self.member, "ReadyStateChanged", function(sender, args) self:UpdateReadyState(); end);
	self:UpdateReadyState();

	self.threshold = 0;
	if self.class == Turbine.Gameplay.Class.Warden then
		self.threshold = 0.5;
	end
	self.threat = 0;
	self.oldMorale = member:GetMorale();
	self.moraleBar = moebius92.ColorBar.ColorBar(6, width - 2, (size - 6) / 2);
	self.moraleBar.tempEnd = 0;
	self.moraleBar.tempEffect = { };
	self.moraleBar.temporaryColor = Turbine.UI.Color(1, 0.5, 0.0, 1.0);
	self.moraleBar:SetBarColor(1, Turbine.UI.Color(1, 0.0, 1.0, 0.0));
	self.moraleBar:SetBarColor(2, Turbine.UI.Color(1, 0.5, 0.0, 1.0));
	self.moraleBar:SetBarColor(3, Turbine.UI.Color(1, 1.0, 0.5, 0.0));
	self.moraleBar:SetBarColor(4, Turbine.UI.Color(1, 0.5, 1.0, 0.5));
	self.moraleBar:SetBarColor(5, Turbine.UI.Color(1, 1.0, 1.0, 0.0));
	self.moraleBar:SetBarColor(6, Turbine.UI.Color(1, 1.0, 0.0, 0.0));
	self.moraleBar:SetParent(self);
	self.moraleBar:SetPosition(size * 6 + 1, 3);
	self.moraleBar:SetMouseVisible(false);
	self.memberHandle["MoraleChanged"] = moebius92.Handlers.AddEventHandler(self.member, "MoraleChanged", function(sender, args) self:UpdateMorale(); end);
	self.memberHandle["MaxMoraleChanged"] = moebius92.Handlers.AddEventHandler(self.member, "MaxMoraleChanged", function(sender, args) self:UpdateMorale(); end);
	self.memberHandle["BaseMaxMoraleChanged"] = moebius92.Handlers.AddEventHandler(self.member, "BaseMaxMoraleChanged", function(sender, args) self:UpdateMorale(); end);
	self.memberHandle["TemporaryMoraleChanged"] = moebius92.Handlers.AddEventHandler(self.member, "TemporaryMoraleChanged", function(sender, args) self:UpdateMorale(); end);
	self.memberHandle["MaxTemporaryMoraleChanged"] = moebius92.Handlers.AddEventHandler(self.member, "MaxTemporaryMoraleChanged", function(sender, args) self:UpdateMorale(); end);
	self:UpdateMorale();

	self.powerBar = moebius92.ColorBar.ColorBar(4, width - 2, (size - 6) / 2);
	self.powerBar.tempEnd = 0;
	self.powerBar.tempEffect = { };
	self.powerBar.temporaryColor = Turbine.UI.Color(1, 0.5, 1.0, 0.0);
	self.powerBar:SetBarColor(1, Turbine.UI.Color(1, 0.0, 0.0, 1.0));
	self.powerBar:SetBarColor(2, Turbine.UI.Color(1, 0.5, 1.0, 0.0));
	self.powerBar:SetBarColor(3, Turbine.UI.Color(1, 1.0, 0.0, 0.5));
	self.powerBar:SetBarColor(4, Turbine.UI.Color(1, 0.5, 0.5, 1.0));
	self.powerBar:SetParent(self);
	self.powerBar:SetPosition(size * 6 + 1, size / 2);
	self.powerBar:SetMouseVisible(false);
	self.memberHandle["PowerChanged"] = moebius92.Handlers.AddEventHandler(self.member, "PowerChanged", function(sender, args) self:UpdatePower(); end);
	self.memberHandle["MaxPowerChanged"] = moebius92.Handlers.AddEventHandler(self.member, "MaxPowerChanged", function(sender, args) self:UpdatePower(); end);
	self.memberHandle["BaseMaxPowerChanged"] = moebius92.Handlers.AddEventHandler(self.member, "BaseMaxPowerChanged", function(sender, args) self:UpdatePower(); end);
	self.memberHandle["TemporaryPowerChanged"] = moebius92.Handlers.AddEventHandler(self.member, "TemporaryPowerChanged", function(sender, args) self:UpdatePower(); end);
	self.memberHandle["MaxTemporaryPowerChanged"] = moebius92.Handlers.AddEventHandler(self.member, "MaxTemporaryPowerChanged", function(sender, args) self:UpdatePower(); end);
	self:UpdatePower();

	self.effects = self.member:GetEffects();
	self.effectsHandle = { };

	self.debuffs = { };
	self.buffs = { };
	for i = 1, 5, 1 do
		self.debuffs[i] = { };
		self.debuffs[i].duration = Turbine.UI.Control();
		self.debuffs[i].duration:SetPosition(0, 0);
		self.debuffs[i].duration:SetSize(size, size);
		self.debuffs[i].duration:SetZOrder(150);
		self.debuffs[i].duration:SetOpacity(0.7);
		self.debuffs[i].duration:SetBackColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.0));
		self.debuffs[i].duration:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply);
		self.debuffs[i].duration:SetMouseVisible(false);
		self.debuffs[i].text = Turbine.UI.Label();
		if debuffType[i] ~= nil then
			self.debuffs[i].text:SetForeColor(debuffColor[debuffType[i]]);
		else
			self.debuffs[i].text:SetForeColor(Turbine.UI.Color(1.0, 1.0, 1.0, 1.0));
		end
		self.debuffs[i].text:SetOutlineColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.0));
		self.debuffs[i].text:SetFontStyle(Turbine.UI.FontStyle.Outline);
		self.debuffs[i].text:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		self.debuffs[i].text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		self.debuffs[i].text:SetPosition(0, 0);
		self.debuffs[i].text:SetSize(size, size);
		self.debuffs[i].text:SetZOrder(200);
		self.debuffs[i].text:SetStretchMode(1);
		self.debuffs[i].text:SetMouseVisible(false);

		if i == 5 and self.parent.class == Turbine.Gameplay.Class.Captain then
			self.buffs[i] = { };
			self.buffs[i].display = Turbine.UI.Control();
			self.buffs[i].display:SetZOrder(101);
			self.buffs[i].display:SetParent(self);
			self.buffs[i].display:SetSize(size, size);
			self.buffs[i].display:SetPosition((i + 5) * size + width, 0);
			self.buffs[i].display:SetVisible(false);
			self.buffs[i].red = Turbine.UI.Control();
			self.buffs[i].red:SetPosition(0, 0);
			self.buffs[i].red:SetSize(36, 36);
			self.buffs[i].red:SetZOrder(102);
			self.buffs[i].red:SetOpacity(0.7);
			self.buffs[i].red:SetBackColor(Turbine.UI.Color(1.0, 1.0, 0.0, 0.0));
			self.buffs[i].red:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply);
			self.buffs[i].red:SetMouseVisible(false);
			self.buffs[i].red:SetParent(self.buffs[i].display);
			self:UpdateBuff(5);
		else
			self.buffs[i] = { };
			self.buffs[i].display = Turbine.UI.Lotro.EffectDisplay();
			self.buffs[i].display:SetZOrder(101);
			self.buffs[i].display:SetParent(self);
			self.buffs[i].display:SetSize(size, size);
			self.buffs[i].display:SetPosition((i + 5) * size + width, 0);
			self.buffs[i].display:SetVisible(false);
			self.buffs[i].duration = Turbine.UI.Control();
			self.buffs[i].duration:SetPosition(0, 0);
			self.buffs[i].duration:SetSize(size, size);
			self.buffs[i].duration:SetZOrder(150);
			self.buffs[i].duration:SetOpacity(0.7);
			self.buffs[i].duration:SetBackColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.0));
			self.buffs[i].duration:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply);
			self.buffs[i].duration:SetMouseVisible(false);
			self.buffs[i].duration:SetParent(self.buffs[i].display);
			self.buffs[i].text = Turbine.UI.Label();
			self.buffs[i].text:SetForeColor(Turbine.UI.Color(1.0, 1.0, 1.0, 1.0));
			self.buffs[i].text:SetOutlineColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.0));
			self.buffs[i].text:SetFontStyle(Turbine.UI.FontStyle.Outline);
			self.buffs[i].text:SetFont(Turbine.UI.Lotro.Font.Verdana12);
			self.buffs[i].text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			self.buffs[i].text:SetPosition(0, 0);
			self.buffs[i].text:SetSize(size, size);
			self.buffs[i].text:SetZOrder(200);
			self.buffs[i].text:SetStretchMode(1);
			self.buffs[i].text:SetMouseVisible(false);
			self.buffs[i].text:SetParent(self.buffs[i].display);
		end
	end

	self.effectID = { };
	self.lastEffectUpdate = 0;
	for i = 1, self.effects:GetCount(), 1 do
		self:AddEffect(self.effects:Get(i));
	end

	self.effectsHandle["EffectAdded"] = moebius92.Handlers.AddEventHandler(self.effects, "EffectAdded", function(sender, args) self:AddEffect(self.effects:Get(args.Index)); end);
	self.effectsHandle["EffectRemoved"] = moebius92.Handlers.AddEventHandler(self.effects, "EffectRemoved", function(sender, args) self:RemoveEffect(args.Effect, true); end);
	self.effectsHandle["EffectsCleared"] = moebius92.Handlers.AddEventHandler(self.effects, "EffectsCleared", function(sender, args) self:ClearEffects(); end);

	self:SetParent(parent);
	self:SetWantsUpdates(true);
	self:SetVisible(true);
end

function PartyMemberWindow:RemoveHandlers()
	for k, v in pairs(self.memberHandle) do
		moebius92.Handlers.RemoveEventHandler(self.member, k, v);
	end
	for k, v in pairs(self.effectsHandle) do
		moebius92.Handlers.RemoveEventHandler(self.effects, k, v);
	end
end

function PartyMemberWindow:UpdateName()
	local x = 1.0;

	if self.dead then
		x = 0.5;
	end

	if self.rollOrder == nil then
		self.name:SetText(self.member:GetName());
	else
		self.name:SetText("(" .. self.rollOrder .. ") " .. self.member:GetName());
	end

	if self.member:IsLinkDead() then
		self.name:SetForeColor(Turbine.UI.Color(1.0, x, 0.0, 0.0));
	elseif self.member:IsVoiceEnabled() then
		self.name:SetForeColor(Turbine.UI.Color(1.0, 0.0, x, 0.0));
	else
		self.name:SetForeColor(Turbine.UI.Color(1.0, x, x, x));
	end
end

function PartyMemberWindow:UpdateReadyState()
	local r = self.member:GetReadyState();
	local c = readyColor[r];

	if c ~= nil then
		if self.leader then
			self.ready:SetBackColor(c);
		else
			self.ready:SetBackColor(Turbine.UI.Color(1.0, c.r / 2.0, c.g / 2.0, c.b / 2.0));
		end
	elseif self.leader then
		self.ready:SetBackColor(Turbine.UI.Color(1.0, 1.0, 1.0, 1.0));
	else
		self.ready:SetBackColor(Turbine.UI.Color(1.0, 0.5, 0.5, 0.5));
	end
end

function PartyMemberWindow:UpdateMorale()
	local cur = self.member:GetMorale();
	local base = self.member:GetBaseMaxMorale();
	local max = self.member:GetMaxMorale();
	local temp = self.member:GetTemporaryMorale();
	local tmax = self.member:GetMaxTemporaryMorale();
	local damage = self.oldMorale - cur;

	if cur == 0 then
		if not self.dead then
			self.dead = true;
			self:UpdateName();
		end
	else
		if self.dead then
			self.dead = false;
			self:UpdateName();
		end
	end

	if self.parent.inCombat and damage > 0 then
		local time = Turbine.Engine.GetGameTime();

		if self.parent.threatTime > 0 then
			local item = { };

			self.damage = self.damage + damage;
			item.damage = damage;
			item.time = time;
			if self.damageTail ~= nil then
				self.damageTail.next = item;
				self.damageTail = item;
			else
				self.damageHead = item;
				self.damageTail = item;
			end

			while self.damageHead ~= nil do
				if (self.damageHead.time + self.parent.threatTime) >= time then
					break;
				end
				self.damage = self.damage - self.damageHead.damage;
				self.damageHead = self.damageHead.next;
			end

			if self.threat < self.damage then
				self.threat = self.damage;
			end
		end
	end

	local m = math.max(max, base) + temp;
	local min = math.min(max, base);

	self.maxMorale = math.max(max, base) + tmax;
	self.oldMorale = cur;
	
	local t = 1.0;
	if self.moraleBar.tempEnd ~= 0 then
		t = math.min(10.0, math.max(0, self.moraleBar.tempEnd - Turbine.Engine.GetGameTime())) / 10.0;
	end
	self.moraleBar:SetBarColor(2, Turbine.UI.Color(1, 0.5, 0.0, t));

	mp = math.max(m, self.parent.maxMorale);
	self.moraleBar:SetStats(1, 0, cur, min, mp);
	self.moraleBar:SetStats(2, max, max + temp, max + temp, mp);
	self.moraleBar:SetStats(3, max + temp, m, m, mp);
	self.moraleBar:SetStats(4, base, cur, max, mp);
	self.moraleBar:SetStats(5, 0, cur, math.floor(max * self.threshold), mp);
	self.moraleBar:SetStats(6, 0, cur, math.min(self.threat, max), mp);
	self.parent:UpdateMorale();
end

function PartyMemberWindow:UpdatePower()
	local cur = self.member:GetPower();
	local base = self.member:GetBaseMaxPower();
	local max = self.member:GetMaxPower();
	local temp = self.member:GetTemporaryPower();
	local tmax = self.member:GetMaxTemporaryPower();

	local m = math.max(max, base) + temp;

	self.maxPower = math.max(max, base) + tmax;

	local t = 1.0;
	if self.powerBar.tempEnd ~= 0 then
		t = math.min(10.0, math.max(0, self.powerBar.tempEnd - Turbine.Engine.GetGameTime())) / 10.0;
	end
	self.powerBar:SetBarColor(2, Turbine.UI.Color(1, 0.5, t, 0.0));

	mp = math.max(m, self.parent.maxPower);
	self.powerBar:SetStats(1, 0, cur, max, mp);
	self.powerBar:SetStats(2, max, max + temp, max + temp, mp);
	self.powerBar:SetStats(3, max + temp, m, m, mp);
	self.powerBar:SetStats(4, math.max(0, max - self.parent.powerFeed), cur, max, mp);
	self.parent:UpdatePower();
end

function PartyMemberWindow:UpdateDebuffTime(i, time)
	if self.debuffs[i].durationTime > 1000000 then
		self.debuffs[i].duration:SetVisible(false);
		return false;
	else
		self.debuffs[i].duration:SetVisible(true);
		self.debuffs[i].duration:SetStretchMode(3);
		self.debuffs[i].duration:SetSize(32, 32);
		self.debuffs[i].duration:SetBackground(baseDurationImageID + math.floor(math.min(59, math.max(0, 60.0 * (time - (self.debuffs[i].startTime + self.debuffs[i].durationTime - 10.0)) / 10.0))));
		self.debuffs[i].duration:SetStretchMode(1);
		self.debuffs[i].duration:SetSize(self.size, self.size);
	end
	return true;
end

function PartyMemberWindow:UpdateBuffTime(i, time)
	if i == 5 and self.parent.class == Turbine.Gameplay.Class.Captain then
		return false;
	elseif self.buffs[i].durationTime > 1000000 then
		self.buffs[i].duration:SetVisible(false);
		return false;
	else
		self.buffs[i].duration:SetVisible(true);
		self.buffs[i].duration:SetStretchMode(3);
		self.buffs[i].duration:SetSize(32, 32);
		self.buffs[i].duration:SetBackground(baseDurationImageID + math.floor(math.min(59, math.max(0, 60.0 * (time - self.buffs[i].startTime) / self.buffs[i].durationTime))));
		self.buffs[i].duration:SetStretchMode(1);
		self.buffs[i].duration:SetSize(self.size, self.size);
	end
	return true;
end

function PartyMemberWindow:UpdateDebuff(i)
	local item = self.debuffs[i].effects;

	if item ~= nil then				
		local ptr = item;

		if self.debuffs[i].display ~= nil then
			self.debuffs[i].display:SetVisible(false);
			self.debuffs[i].display:SetParent(nil);
		end

		self.debuffs[i].display = Turbine.UI.Lotro.EffectDisplay();
		self.debuffs[i].display:SetZOrder(100);
		self.debuffs[i].display:SetParent(self);
		self.debuffs[i].display:SetPosition(i * self.size, 0);
		self.debuffs[i].display:SetSize(self.size, self.size);
		self.debuffs[i].duration:SetParent(self.debuffs[i].display);
		self.debuffs[i].text:SetParent(self.debuffs[i].display);
		self.debuffs[i].display:SetEffect(item.effect);

		n = 0;
		while ptr ~= nil do
			if ptr.effect:IsDebuff() and ptr.effect:IsCurable() then
				n = n + 1;
			end
			ptr = ptr.next;
		end

		if n > 1 then
			self.debuffs[i].text:SetText(tostring(n));
			self.debuffs[i].text:SetVisible(true);
		else
			self.debuffs[i].text:SetVisible(false);
		end

		self.debuffs[i].startTime = item.effect:GetStartTime();
		self.debuffs[i].durationTime = item.effect:GetDuration();
		self:UpdateDebuffTime(i, Turbine.Engine.GetGameTime());
		self.debuffs[i].display:SetVisible(true);
	else
		self.debuffs[i].display:SetVisible(false);
	end
	self:SetWantsUpdates(true);
end

function PartyMemberWindow:UpdateBuff(i)
	if i == 5 and self.parent.class == Turbine.Gameplay.Class.Captain then
		local ptr;

		for j = 1, #captainBuffs, 1 do
			local found = true;

			if j == 3 then
				local effects = self.parent.player:GetEffects();
				found = false;

				for k = 1, effects:GetCount(), 1 do
					if captainBuffs[j].name[effects:Get(k):GetName()] then
						found = true;
						break;
					end
				end
			end

			if found then
				ptr = self.buffs[i].effects;
				while ptr ~= nil do
					if captainBuffs[j].name[ptr.effect:GetName()] then
						break;
					end
					ptr = ptr.next;
				end

				if ptr == nil then
					self.buffs[i].display:SetStretchMode(3);
					self.buffs[i].display:SetSize(33, 33);
					self.buffs[i].display:SetBackground(captainBuffs[j].icon);
					self.buffs[i].display:SetStretchMode(1);
					self.buffs[i].display:SetSize(self.size, self.size);
					self.buffs[i].display:SetVisible(true);
					return;
				end
			end
		end

		self.buffs[i].display:SetVisible(false);
	else
		local item = self.buffs[i].effects;

		if item ~= nil then				
			self.buffs[i].display:SetEffect(item.effect);

			local name = item.effect:GetName();
			if #name > 6 and string.sub(name, #name - 5, #name - 2) == "Tier" then
				self.buffs[i].text:SetText(string.sub(name, #name));
				self.buffs[i].text:SetVisible(true);
			else
				local ptr = item;
				n = 0;
				while ptr ~= nil do
					n = n + 1;
					ptr = ptr.next;
				end

				if n > 1 then
					self.buffs[i].text:SetText(tostring(n));
					self.buffs[i].text:SetVisible(true);
				else
					self.buffs[i].text:SetVisible(false);
				end
			end

			self.buffs[i].startTime = item.effect:GetStartTime();
			self.buffs[i].durationTime = item.effect:GetDuration();
			self:UpdateBuffTime(i, Turbine.Engine.GetGameTime());
			self.buffs[i].display:SetVisible(true);
		else
			self.buffs[i].display:SetEffect(nil);
			self.buffs[i].display:SetVisible(false);
		end
		self:SetWantsUpdates(true);
	end
end

function PartyMemberWindow:AddEffect(effect)
	local id;
	local time = Turbine.Engine.GetGameTime();
	local name = effect:GetName();

	self.lastEffectUpdate = time;
	for i = 1, self.effects:GetCount(), 1 do
		id = self.effects:Get(i):GetID();

		if self.effectID[id] ~= nil then
			self.effectID[id].time = time;
		end
	end

	id = effect:GetID();

	if name == "Word of Exaltation" or
	   name == "Joy of Battle" or
	   name == "Glory of Battle" or
	   name == "Sudden Defence" or
	   name == "Song of the Hammerhand" or
	   name == "Gift of the Hammerhand" then
		self.moraleBar.tempEffect[id] = effect:GetStartTime() + effect:GetDuration();
		self.moraleBar.tempEnd = 0;
		for _, v in pairs(self.moraleBar.tempEffect) do
			self.moraleBar.tempEnd = math.max(self.moraleBar.tempEnd, v);
		end
	end

	if self.effectID[id] == nil then
		local item = { };

		item.effect = effect;
		item.time = time;
		item.endTime = effect:GetStartTime() + effect:GetDuration();
		if effect:IsDebuff() or name == "Recovering" then
			if effect:IsCurable() then
				local i = debuffOrder[effect:GetCategory()];

				if i ~= nil then
					item.order = -i;
					item.next = self.debuffs[i].effects;
					self.debuffs[i].effects = item;
					self.effectID[id] = item;
					self:UpdateDebuff(i);
				end
			elseif combatStates[name] then
				item.order = -1;
				item.next = self.debuffs[1].effects;
				self.debuffs[1].effects = item;
				self.effectID[id] = item;
				self:UpdateDebuff(1);
			end
		else
			local i;
			
			i = buffOrder[self.parent.class][name];
			if i ~= nil then
				item.order = i;
				if i < 0 then
					local ptr = self.debuffs[-i].effects;

					if ptr == nil then
						self.debuffs[-i].effects = item;
					else
						while ptr.next ~= nil do
							ptr = ptr.next;
						end
						ptr.next = item;
					end
					self.effectID[id] = item;
					self:UpdateDebuff(-i);
				else
					item.next = self.buffs[i].effects;
					self.buffs[i].effects = item;
					self.effectID[id] = item;
					self:UpdateBuff(i);
				end
			end
		end
	end
end

function PartyMemberWindow:RemoveEffect(effect, mark)
	local id;
	local time = Turbine.Engine.GetGameTime();
	local name = effect:GetName();

	if mark then
		self.lastEffectUpdate = time;
		for i = 1, self.effects:GetCount(), 1 do
			id = self.effects:Get(i):GetID();

			if self.effectID[id] ~= nil then
				self.effectID[id].time = time;
			end
		end
	end

	id = effect:GetID();

	if name == "Word of Exaltation" or
	   name == "Joy of Battle" or
	   name == "Glory of Battle" or
	   name == "Sudden Defence" or
	   name == "Song of the Hammerhand" or
	   name == "Gift of the Hammerhand" then
		self.moraleBar.tempEffect[id] = nil;
		self.moraleBar.tempEnd = 0;
		for _, v in pairs(self.moraleBar.tempEffect) do
			self.moraleBar.tempEnd = math.max(self.moraleBar.tempEnd, v);
		end
	end

	if self.effectID[id] ~= nil then
		local ptr = nil;
		local prev = nil;

		i = self.effectID[id].order;
		self.effectID[id] = nil;

		if i < 0 then
			ptr = self.debuffs[-i].effects;
		else
			ptr = self.buffs[i].effects;
		end

		while ptr.effect ~= effect and ptr ~= nil do
			prev = ptr;
			ptr = ptr.next;
		end

		if ptr ~= nil then
			if prev == nil then
				if i < 0 then
					self.debuffs[-i].effects = ptr.next;
				else
					self.buffs[i].effects = ptr.next;
				end
			else
				prev.next = ptr.next;
			end
			if i < 0 then
				self:UpdateDebuff(-i);
			else
				self:UpdateBuff(i);
			end
		end
	end
end

function PartyMemberWindow:ClearEffects()
	for i = 1, 5, 1 do
		self.debuffs[i].effects = nil;
		self:UpdateDebuff(i);
		self.buffs[i].effects = nil;
		self:UpdateBuff(i);
	end
	self.effectID = { };
end

function PartyMemberWindow:Update()
	local time = Turbine.Engine.GetGameTime();
	local update = false;

	if self.moraleBar.tempEnd ~= 0 then
		self:UpdateMorale();
	end

	if self.powerBar.tempEnd ~= 0 then
		self:UpdatePower();
	end

	for i = 1, 5, 1 do
		if self.debuffs[i].effects ~= nil then
			if self:UpdateDebuffTime(i, time) then
				update = true;
			end
		end
		if self.buffs[i].effects ~= nil then
			if self:UpdateBuffTime(i, time) then
				update = true;
			end
		end
	end

	if self.lastEffectUpdate == time then
		for k, v in pairs(self.effectID) do
			if v.time ~= time then
				self:RemoveEffect(v.effect, false);
			end
		end
	else
		for k, v in pairs(self.effectID) do
			if v.endTime <= time then
				self:RemoveEffect(v.effect, false);
			end
		end
	end

--	if not update then
--		self:SetWantsUpdates(false);
--	end
end

PartyFrameWindow = class(Turbine.UI.Window);

function PartyFrameWindow:Constructor(size, width)
	Turbine.UI.Window.Constructor(self);

	self.size = size;
	self.width = width;
	self.w = Turbine.UI.Display:GetWidth();
	self.h = Turbine.UI.Display:GetHeight();

	self.visible = true;
	self.hide = false;
	self:SetWantsKeyEvents(true);

	self:SetSize(self.size * 11 + self.width, self.size);
	self:SetPosition(self.w - (self.size * 11 + self.width), self.h / 2.0);

	self.threatTime = 5;
	self.powerFeed = 1400;
	self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	self.class = self.player:GetClass();
	self.maxMorale = 1;
	self.maxPower = 1;
	self.inCombat = self.player:IsInCombat();

	self.members = { };
	self.partyHandle = { };

	self:UpdateParty();
	moebius92.Handlers.AddEventHandler(self.player, "InCombatChanged", function(sender, args) self:CombatChange(); end);
	moebius92.Handlers.AddEventHandler(self.player, "PartyChanged", function(sender, args) self:UpdateParty(); end);
	moebius92.Handlers.AddChatHandler(function(m) self:ChatMessage(m) end, Turbine.ChatType.Standard, nil);
end

function PartyFrameWindow:SetVisible(v)
	if v ~= nil then
		self.visible = v;
	end
	Turbine.UI.Window.SetVisible(self, self.visible and not self.hide);
end

function PartyFrameWindow:KeyDown(args)
	if args.Action == 0x100000B3 then
		self.hide = not self.hide;
		self:SetVisible();
	end
end

function PartyFrameWindow:ChatMessage(m)
	local i = string.find(m, " ");

	if i ~= nil then
		local name = string.sub(m, 1, i - 1);

		m = string.sub(m, i + 1, -1);
		if string.sub(m, 1, 14) == "rolled (100): " then
			if self.members[name] then
				local t = { };
				local i, j, k;
				local state, w;

				table.insert(self.members[name].rolls, tonumber(string.sub(m, 15, -1)));
				self.members[name]:UpdateName();

				for k, v in pairs(self.members) do
					table.insert(t, { ["rolls"] = v.rolls, ["name"] = k });
				end
				table.sort(t, 
function(a, b)
	local n = math.min(#a.rolls, #b.rolls);
	local i;

	for i = 1, math.min(#a.rolls, #b.rolls), 1 do
		if a.rolls[i] > b.rolls[i] then
			return true;
		elseif a.rolls[i] < b.rolls[i] then
			return false;
		end
	end

	return #a.rolls > #b.rolls;
end
				          );

				k = 0;
				for i = 1, #t, 1 do
					if #t[i].rolls == 0 then
						break;
					end

					state = 0;
					if i == 1 then
						state = 2
					else
						for j = 1, #t[i].rolls, 1 do
							if t[i - 1].rolls[j] > t[i].rolls[j] then
								state = 2;
								break;
							end
						end

						if state == 0 then
							if #t[i - 1].rolls > #t[i].rolls then
								state = 1;
							end
						end
					end

					if state == 2 then
						k = k + 1;
					end
					
					if state == 1 then
						w = k .. "?";
					else
						w = k
					end

					if self.members[t[i].name].rollOrder ~= w then
						self.members[t[i].name].rollOrder = w;
						self.members[t[i].name]:UpdateName();
					end
				end
			end
		end
	end
end

function PartyFrameWindow:AddMember(member, name, j)
	if not self.members[name] then
		self.members[name] = PartyMemberWindow(self, member, self.size, self.width);
	end

	if not self.members[name].exists then
		self.members[name].exists = true;
		self.members[name]:SetPosition(0, self.size * (j - 1));
		self.members[name]:SetVisible(true);
		self.members[name]:UpdateReadyState();
		return true;
	end
	return false;
end

function PartyFrameWindow:UpdateParty()
	for k, v in pairs(self.partyHandle) do
		moebius92.Handlers.RemoveEventHandler(self.party, k, v);
	end
	self.partyHandle = { };

	for k, v in pairs(self.members) do
		v:RemoveHandlers();
		v:SetVisible(false);
		v:SetParent(nil);
	end
	self.members = { };

	self.party = self.player:GetParty();

	if self.party ~= nil then
		self.partyHandle["MemberAdded"] = moebius92.Handlers.AddEventHandler(self.party, "MemberAdded", function(sender, args) self:PartyMemberChanged(); end);
		self.partyHandle["MemberRemoved"] = moebius92.Handlers.AddEventHandler(self.party, "MemberRemoved", function(sender, args) self:PartyMemberChanged(); end);
		self.partyHandle["LeaderChanged"] = moebius92.Handlers.AddEventHandler(self.party, "LeaderChanged", function(sender, args) self:PartyMemberChanged(); end);

	end

	self:PartyMemberChanged();
end

function PartyFrameWindow:PartyMemberChanged(order)
	if self.party ~= nil and self.party:GetMemberCount() > 1 then
		local n = self.party:GetMemberCount();
		local l = self.party:GetLeader();
		local lname = l:GetName();
		local o = { };

		if order == nil then
			order = self.order;
		end

		if order ~= nil then
			for v in string.gmatch(order, "[^ ]+") do
				v = trim(v);
				for v1 in string.gmatch(v, "[^,]+") do
					o[v1] = 0;
				end
			end
			self.order = order;
		end

		for k, v in pairs(self.members) do
			v.exists = false;
			v.leader = false;
		end

		j = 1;

		if o[self.player:GetName()] == nil then
			if self:AddMember(self.player, self.player:GetName(), j) then
				j = j + 1;
			end
		end

		if o[lname] == nil then
			if self:AddMember(l, lname, j) then
				j = j + 1;
			end
		end

		for	i = 1, n, 1 do
			local member = self.party:GetMember(i);
			local name = member:GetName();

			if o[name] == nil then
				if self:AddMember(member, name, j) then
					j = j + 1;
				end
			else
				o[name] = i;
			end
		end

		if order ~= nil then
			for v in string.gmatch(order, "[^ ]+") do
				if j > 1 then
					j = j + 1;
				end

				v = trim(v);
				for v1 in string.gmatch(v, "[^,]+") do
					if o[v1] ~= 0 then
						local member = self.party:GetMember(o[v1]);
						local name = member:GetName();

						if self:AddMember(member, name, j) then
							j = j + 1;
						end
					else
						Turbine.Shell.WriteLine(v1 .. " not found.");
					end
				end
			end
		end

		if o[lname] == nil then
			self.members[lname].leader = true;
			self.members[lname]:UpdateReadyState();
		end

		for k, v in pairs(self.members) do
			if not v.exists then
				v:RemoveHandlers();
				v:SetVisible(false);
				v:SetParent(nil);
				self.members[k] = nil;
			end
		end

		self:UpdateMorale();
		self:UpdatePower();
		for k, v in pairs(self.members) do
			v:UpdateMorale();
			v:UpdatePower();
		end

		self:SetTop(math.max(0, self.h / 2 - self.size * (j - 1)));
		self:SetHeight(self.size * (j - 1));
		self:SetVisible(false);
		self:SetVisible(true);
	else
		self:SetVisible(false);
	end
end

function PartyFrameWindow:UpdateMorale()
	local m = 1;

	for k, v in pairs(self.members) do
		m = math.max(m, v.maxMorale);
	end

	if m ~= self.maxMorale then
		self.maxMorale = m;
		for k, v in pairs(self.members) do
			v:UpdateMorale();
		end
	end
end

function PartyFrameWindow:UpdatePower()
	local m = 1;

	for k, v in pairs(self.members) do
		m = math.max(m, v.maxPower);
	end

	if m ~= self.maxPower then
		self.maxPower = m;
		for k, v in pairs(self.members) do
			v:UpdatePower();
		end
	end
end

function PartyFrameWindow:CombatChange()
	self.inCombat = self.player:IsInCombat();
	for k, v in pairs(self.members) do
		v.damageHead = nil;
		v.damageTail = nil;
		v.damage = 0;
		v.threat = 0;
		v:UpdateMorale();
	end
end

PartyFrameCommand = class(Turbine.ShellCommand);

function PartyFrameCommand:Execute(command, arguments)
	local party = partyFrameWindow.player:GetParty();

	if party ~= partyFrameWindow.party then
		partyFrameWindow:UpdateParty();
	end

	if arguments == "clear" then
		for k, v in pairs(partyFrameWindow.members) do
			v.rolls = { };
			v.rollOrder = nil;
			v:UpdateName();
		end
	elseif partyFrameWindow.party ~= nil then
		partyFrameWindow:PartyMemberChanged(arguments);
	end
end

function PartyFrameCommand:GetShortHelp()
	return "PartyFrame";
end

partyFrameCommand = PartyFrameCommand();
Turbine.Shell.AddCommand('partyFrame', partyFrameCommand);
Turbine.Shell.AddCommand('pf', partyFrameCommand);

_G.partyFrameWindow = PartyFrameWindow(22, 100);